Subject: Re: [ovs-dev] [PATCH] tests: fix reference output for meter offload stats

From: Simon Horman <[email-masked]>
Date: Tue, 22 Nov 2022 12:31:16 +0100

On Wed, Oct 19, 2022 at 02:28:29PM +0200, Simon Horman wrote:
> On Wed, Oct 19, 2022 at 02:17:42PM +0200, Ilya Maximets wrote:
> > On 10/19/22 10:12, Simon Horman wrote:
> > > On Fri, Oct 14, 2022 at 10:40:30AM -0400, Jamal Hadi Salim wrote:
> > >> On Fri, Oct 14, 2022 at 9:00 AM Ilya Maximets <[email-masked]> wrote:
> > >>>
> > >>
> > >> [..]
> > >>>> I thought it was pipe but maybe it is OK(in my opinion that is a bad code
> > >>>> for just "count"). We have some (at least NIC) hardware folks on the list.
> > >>>
> > >>> IIRC, 'OK' action will stop the processing for the packet, so it can
> > >>> only be used as a last action in the list.  But we need to count packets
> > >>> as a very first action in the list.  So, that doesn't help.
> > >>>
> > >>
> > >> That's why i said it is a bad code - but i believe it's what some of
> > >> the hardware
> > >> people are doing. Note: it's only bad if you have more actions after because
> > >> it aborts the processing pipeline.
> > >>
> > >>>> Note: we could create an alias to PIPE and call it COUNT if it helps.
> > >>>
> > >>> Will that help with offloading of that action?  Why the PIPE is not
> > >>> offloadable in the first place and will COUNT be offloadable?
> > >>
> > >> Offloadable is just a semantic choice in this case. If someone is
> > >> using OK to count  today - they could should be able to use PIPE
> > >> instead (their driver needs to do some transformation of course).
> > > 
> > > FWIIW, yes, that is my thinking too.
> > 
> > I don't know that code well, but I thought that tcf_gact_offload_act_setup()
> > is a generic function.  And since it explicitly forbids offload of PIPE
> > action, no drivers can actually offload it even if they want to.
> 
> Sure, but I would expect that can be changed.

RFC kernel patch posted:
* https://lore.kernel.org/netdev/[email-masked]/

> > So it's not really a driver's choice in the current kernel code.  Or am I
> > missing something?
> >
> > Best regards, Ilya Maximets.